Subject: [Idr] Inter-operable BGP implementations - Call for information

From: "Susan Hares" <[email-masked]>
Date: Thu, 20 May 2004 00:18:05 -0400

IDR folks: 

I am revising the BGP implementation survey, and
need an updated on inter-operable implementations.
I will accept input for 2 weeks ending 6/2/04.  
At that time, I will release version -01 of the BGP
implementation survey. 

If you have an implementation of BGP and
you did not send in an implementation report
(answering the 259 questions),  could
you send me the answer the following questions

1) BGP product
	Contributor (your name): 
	Company: 
	name of product: 
	version and minor of software
	release date

2) What other implementations you 
     interoperate with.

3) Do you inter-operate with

	1) Alcatel BGP (release) 
	2) cisco BGP IOS 12.0(27)s
	3) laurel BGP (specify release)
	4) NextHop GateD

4) Did the length of the survey for BGP
   cause you to not submit the BGP
   implementation report?

Sue Hares 

_______________________________________________
Idr mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/idr

---

From: "Susan Hares" <[email-masked]>
Date: Fri, 21 May 2004 17:59:26 -0400

Curtis and Pekka:

I sent off a bit longer explanation
earlier.  Please let me know if it
was enough.

Having been too verboose this
last week, I was too terse
in the request.

Sue

oh-- well.

-----Original Message-----
From: Curtis Villamizar [mailto:[email-masked]]
Sent: Thursday, May 20, 2004 12:49 PM
To: Pekka Savola
Cc: Susan Hares; [email-masked]
Subject: Re: [Idr] Inter-operable BGP implementations - Call for
information 

In message <[email-masked]>, Pekka Savola 
writes:
> On Thu, 20 May 2004, Susan Hares wrote:
> FWIW, if you look at RFC2026, it's not sufficient that you have
> interoperable implementations (in general), there must be two
> interoperable implementations of _every feature_ of the spec.
> 
> >From 4.1.2,
>                                                             For the
>    purposes of this section, "interoperable" means to be functionally
>    equivalent or interchangeable components of the system or process in
>    which they are used.
> 
> The interpretation of what this means has been quite blur, but it 
> would be better that if interop tests explicitly tested each feature 
> of the spec, not the spec as a whole.
> 
> -- 
> Pekka Savola                 "You each name yourselves king, yet the
> Netcore Oy                    kingdom bleeds."
> Systems. Networks. Security. -- George R.R. Martin: A Clash of Kings

Field experience has already proven many BGP implementations to be
interoperable by the definition above.  You can pull out a brand X
router and put in a brand Y router it all works fine, for a large set
of X and Y.

The spec has a lot of MUST and SHOULD and the first survey asked for
an answer for each one of them.  A lot of providers just didn't make
it through verifying which of the SHOULDs they needed to check off
before the cutoff for accepting these (which was just a few weeks).

I don't really know Sue's motivation for this latest request.

What might me useful would be to include the responses to the original
survey, add any that come in, and include the interoperability
experience (without full surveys) that Sue has asked for just as
further evidence that there are a lot of interoperable BGP
implementations.

We should be able to update the protocol experiences doc (if we want
to) after the whole set goes through six months or a year from now if
additional vendors come forward with completed surveys.

Curtis

---

From: "Susan Hares" <[email-masked]>
Date: Fri, 21 May 2004 17:59:25 -0400

Pekka:

In my earlier messages I assumed a context
from bgp-4 implementation report found
for your reading pleasure (and accessed
off the general IDR web page) at:

 draft-ietf-idr-bgp-implementation-00.txt 

In that report (authored by Alvaro and
myself), we have 4 inter-operable (Alcatel,
Cisco, Laurel, NextHop) whose inventors
responded to 259 questions required to verify
all features of the protocols.
This required a significant investment
of time on for any implementer.  
All issues from RFC 2026 are covered
in that document. 

Since there are greater than four implementations
of BGP in existence, the small subset of
responses will be of concern to any
member of the IESG with functioning
and engaged cognitive processes.  

Informal reports to me indicated that
for an existing and deployed implementation, this
effort had value only for the continuation of
the IETF standard process.   In order to
provide appropriate input to the IESG on
general interoperability of BGP, I need to
widen the normal 2026 survey to
include those implementations that: 	

 a)Are inter-operable with other BGP implementation, and
 b)whose implementers found that answering 259
   questions on an existing and deployed 
   implementations was too daunting to
   complete.

Section 1.4 of the implementation report
deals with this issue.  At the time of the -00.txt
draft this was incomplete because I 
did not have enough time to get a significant
number of responses.  I am now asking for
those responses in the next 2 weeks. 

Does this make the request clear? 

Perhaps this two facts will also illuminate the
value of this request to the working group.
For example, neither Juniper or Redback's
implementers filled out an implementation report.
Juniper's support of BGP standardization process has
been evident by my esteemed co-chairs active
participation for years.  Other standards or
standards reports have been generated by 
many fine BGP implementers at Juniper or Redback.

I normally attempt to be brief and assume
a substantial amount of context from existing
documents.  Please send me feedback if I am
being to terse in the future.  

Sue 

-----Original Message-----
From: Pekka Savola [mailto:[email-masked]]
Sent: Thursday, May 20, 2004 1:52 AM
To: Susan Hares
Cc: [email-masked]
Subject: Re: [Idr] Inter-operable BGP implementations - Call for
information

                                                            For the

---

From: "Susan Hares" <[email-masked]>
Date: Fri, 21 May 2004 17:59:26 -0400

Curtis and Pekka:

Sue

oh-- well.

-----Original Message-----
From: Curtis Villamizar [mailto:[email-masked]]
Sent: Thursday, May 20, 2004 12:49 PM
To: Pekka Savola
Cc: Susan Hares; [email-masked]
Subject: Re: [Idr] Inter-operable BGP implementations - Call for
information 

Curtis

---

From: "Susan Hares" <[email-masked]>
Date: Sat, 22 May 2004 09:18:13 -0400

Pekka and Curtis:

This is an information section for the IESG.

The implementation and inter-operability is
given by the 4 implementations that sent in the
questionnaire: Alcatel, Laurel, Cisco and NextHop.

I'd welcome any other implementation who'd
like to fill out the 259 questions.

sue

-----Original Message-----
From: Curtis Villamizar [mailto:[email-masked]]
Sent: Saturday, May 22, 2004 2:30 AM
To: Pekka Savola
Cc: Susan Hares; [email-masked]
Subject: Re: [Idr] Inter-operable BGP implementations - Call for
information 

In message <[email-masked]>, Pekka Savola w
rites:
> On Fri, 21 May 2004, Susan Hares wrote:
> Not quite.  RFC2026 requires *both* implementation and
> interoperability of 'functionally equivalent or interchangeable
> components'.  The document just describes implementation in
> excruciating detail (good! :).
> 
> Even though implementations are known to interoperate in general, I 
> don't think anyone has made a question-by-question interoperability 
> test .. which, depending on how you interpret RFC2026 language, could 
> be required.

Sounds to me more like Corperation for Open Sytems (or or whatever
they were called) that the IETF.

I don't think we're going to arrive at any sort of provable
correctness.

Maybe we should look at what OSPF did.

Curtis

---

From: "Susan Hares" <[email-masked]>
Date: Sat, 22 May 2004 09:18:13 -0400

Pekka and Curtis:

sue

-----Original Message-----
From: Curtis Villamizar [mailto:[email-masked]]
Sent: Saturday, May 22, 2004 2:30 AM
To: Pekka Savola
Cc: Susan Hares; [email-masked]
Subject: Re: [Idr] Inter-operable BGP implementations - Call for
information 

Curtis

---

From: "Susan Hares" <[email-masked]>
Date: Sat, 22 May 2004 11:10:22 -0400

Curtis: 

Thanks for sending out this note.

My motivation was to show that there are
a lot of inter-operable implementations --
but the survey was too long.

I am trying to take an informal survey
(no RFC 2119 binding) to find out of
those who have a BGP4 implementation
that matches draft-ietf-idr-bgp4-23.txt 
(shortly to be -24.txt)

1) Why did you not respond to the survey:
	a) length of survey
	b) other (please comment)
2) Do you interoperate with other BGP 
   implementations?

  If so, which bgp implementations?
 
For those that respond, I will need:
1) contact (email, name) if different than
   the person sending in the response.

2) implementation: product/revision
   and date of revision.

So...anyone else who wants to send
me this information, please send it 
within the next 2 weeks. 

Sue

-----Original Message-----
From: Curtis Villamizar [mailto:[email-masked]]
Sent: Thursday, May 20, 2004 12:49 PM
To: Pekka Savola
Cc: Susan Hares; [email-masked]
Subject: Re: [Idr] Inter-operable BGP implementations - Call for
information 

Curtis

---

From: "Susan Hares" <[email-masked]>
Date: Sat, 22 May 2004 11:10:22 -0400

Curtis: 

 

Sue

-----Original Message-----
From: Curtis Villamizar [mailto:[email-masked]]
Sent: Thursday, May 20, 2004 12:49 PM
To: Pekka Savola
Cc: Susan Hares; [email-masked]
Subject: Re: [Idr] Inter-operable BGP implementations - Call for
information 

Curtis